       parameter (M=11, NN=2**M)
       complex C(0:NN), D(0:NN), Z(0:NN)
       complex w, u

       do 100 KK=1, 3

       pi=4.0*atan(1.0)
       w=cmplx(cos(-2*pi/NN), sin(-2*pi/NN))

       do 10 k=0, NN-1
          Z(k)=w**k
          C(k)=cos(5*2*pi*k/NN)
 10    continue

       do 20 n=0, NN-1
          u=C(0)
          do 30 k=1, NN-1
             u=u+Z(n)**k*C(k)
 30       continue
          D(n)=u/NN
 20    continue

 100    continue

c       do 99 j=0, NN-1
c          write (11, *) D(j)
c          print *, D(j)
c 99    continue    

       stop
       end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc  This code uses the standard RK3, without modifying
cc  the u bar values
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       parameter (N=64, NN=2*N+1)
       implicit real*8(a-h,o-z)
       real x(0:NN), ubar(0:NN,0:3)
       real uapp1(0:NN), xL(0:NN,0:3), si(0:NN)
       complex abar(0:NN), al(0:NN)
       complex w, A, y, ss, ss1, ss2, F, sum, sum1

       pi=4.0*atan(1.0)
       w=cmplx(0, 1)
       alpha=15.0*log(10.0)

       dx=2.0*pi/NN
       dx1=0.5*dx
       N2=0.0*N
       dt=0.005
       ttime=0.0
       Tmax=2.0
       par=1.9

c compute the initial fourier coefficient
       do j=0, NN
          x(j)=j*dx
          if ( (x(j)-dx1) .lt. par .and. (x(j)+dx1) .gt. par) jp=j
       enddo

       do j=0, NN

          s1=cos(0.5*(x(j)+dx1))
          s2=cos(0.5*(x(j)-dx1))

          if (j .lt. jp) then
             ubar(j, 0)=-2.0*(s1-s2)/dx
           elseif (j .gt. jp) then
             ubar(j, 0)=2.0*(s1-s2)/dx
           else
             p1=-2.0*(cos(0.5*par)-s2)/dx
             p2=2.0*(s1-cos(0.5*par))/dx
             ubar(j, 0)=p1+p2
          endif
 
          s1=-cos(x(j)+dx1)
          s2=cos(x(j)-dx1)
c          ubar(j, 0)=0.3+0.7*(s1+s2)/dx
       enddo

 99    do NR=0, 2

       do k=0, NN-1
           k1=k-0.5*(NN-1)
           ss=0.0
           do j=0, NN-1
              p1=k1*x(j)
              s1=cos(p1)
              s2=-sin(p1)
              ss=ss+ubar(j,NR)*cmplx(s1,s2)
           enddo
           abar(k)=ss/NN
       enddo

       do k=0, NN-1
           k1=k-0.5*(NN-1)

           if (k1 .eq. 0) then
           si(k)=1.0
           else
           p1=0.5*k1*dx
           p2=sin(p1)
           si(k)=p2/p1
           endif

           al(k)=abar(k)/si(k)

       enddo

c compute the shock location

         N1=(1.0*N)**0.6
         ss=(N1+1)*al(N+N1+1)/((N1+2)*al(N+N1+2))
         y=-w*log(ss)
         ss=w*(N1+1)*y
         A=w*(N1+1)*al(N+N1+1)*exp(ss)
         if (NR .eq. 2) print *, 'haaaaaaaaaaa', A, y
         if (y1 .gt. 2.*pi .or. y1 .lt. 0.0) then
             y1=0.0
             y=0.0
         endif
         y1=real(y)
         y=real(y)
         A=real(A)

      do j=0, NN-1
         xj=(j+0.5)*dx
          if (xj .le. y1 ) then
             F=-A*xj
          else
             F=A*(2*pi-xj)
          endif
         
          sum=0.0
          do k=1, N
             if ( k .le. N2) then
                 tau=1.0
             else
                 tau=exp(-alpha*(1.0*(k-N2)/N)**8)
             endif

             ps=k*y1
             s1=cos(ps)
             s2=-sin(ps)
             ss1=cmplx(s1, s2)
             ps=k*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=(al(k+N)+w*A*ss1/k)*ss2
             sum=sum+tau*ss

             k1=-k
             ps=k1*y1
             s1=cos(ps)
             s2=-sin(ps)
             ss1=cmplx(s1, s2)
             ps=k1*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=(al(k1+N)+w*A*ss1/k1)*ss2

             sum=sum+tau*ss
          enddo

          uapp1(j)=real(al(N)-A*(pi-y)+sum+F)

       enddo

c Runge-Kutta

       do j=0, NN-1
          ss1=uapp1(j)
          if (j .eq. 0) then
             ss2=uapp1(NN-1)
             else
             ss2=uapp1(j-1)
          endif
          xL(j, NR)=-0.5*(ss1*ss1-ss2*ss2)/dx

          if (NR .eq. 0) then
             ubar(j,1)=ubar(j,0)+dt*xL(j,0)
          endif

          if (NR .eq. 1) then
             sa=0.75*ubar(j,0)+0.25*ubar(j,1)+0.25*dt*xL(j,1)
             ubar(j,2)=sa
          endif

          if (NR .eq. 2) then
             sa=ubar(j,0)/3.0+ubar(j,2)*2/3.0+dt*xL(j,2)*2/3.0
             ubar(j,3)=sa
          endif

        enddo

       enddo

       ttime=ttime+dt
       print *, ttime, '    time'
       if (ttime .lt. Tmax) then
          do j=0, NN
            ubar(j,0)=ubar(j, 3)
          enddo
          goto 99
       endif

       do k=0, NN-1
           k1=k-0.5*(NN-1)
           ss=0.0
           do j=0, NN-1
              p1=k1*x(j)
              s1=cos(p1)
              s2=-sin(p1)
              ss=ss+ubar(j,NR)*cmplx(s1,s2)
           enddo
           abar(k)=ss/NN
           al(k)=abar(k)/si(k)
       enddo

      do j=0, NN-1
         xj=x(j)

        if (xj .le. y1 ) then
             F=-A*xj
          else
             F=A*(2*pi-xj)
          endif

          sum=0.0
          do k=1, N
             if ( k .le. N2) then
                 tau=1.0
             else
                 tau=exp(-alpha*(1.0*(k-N2)/N)**4)
             endif

             ps=k*y1
             s1=cos(ps)
             s2=-sin(ps)
             ss1=cmplx(s1, s2)
             ps=k*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=(al(k+N)+w*A*ss1/k)*ss2
             sum=sum+tau*ss

             k1=-k
             ps=k1*y1
             s1=cos(ps)
             s2=-sin(ps)
             ss1=cmplx(s1, s2)
             ps=k1*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=(al(k1+N)+w*A*ss1/k1)*ss2

             sum=sum+tau*ss
          enddo

          uapp1(j)=real(al(N)-A*(pi-y)+sum+F)
       enddo

       write (17, *) 'x=['
       do j=0, NN-1
          write (17, *) x(j)
       enddo
       write (17, *) '];'

        write (18, *) 'y=['
       do j=0, NN-1
          write (18, *) real(uapp1(j))
       enddo
       write (18, *) '];'

       print *, A, y, '   A, y'
       
       stop
       end

       parameter (N=64, NN=2*N+1)
       implicit real*8(a-h,o-z)
       real x(0:NN+1),ubar(0:NN+1,0:3)
       real uapp1(0:NN+1), xL(0:NN+1,0:3)
       complex abar(0:NN+2), al(0:NN+2), si(0:NN+1)
       complex w, A, y, ss, ss1, ss2, sum, sum1

       pi=4.0*atan(1.0)
       w=cmplx(0, 1)
       alpha=15.0*log(10.0)

       dx=2.0*pi/NN
       dx1=0.5*dx
       dt=0.01
       ttime=0.0
       Tmax=0.5

       par=1.9

c compute the initial fourier coefficient
       do j=0, NN
          x(j)=j*dx
          if ( (x(j)-dx1) .lt. par .and. (x(j)+dx1) .gt. par) jp=j
       enddo

       do j=0, NN
          x(j)=j*dx
c          ubar(j, 0)=0.3+0.7*(-cos(x(j)+0.5*dx)+cos(x(j)-0.5*dx))/dx

          s1=cos(0.5*(x(j)+dx1))
          s2=cos(0.5*(x(j)-dx1))

          if (j .lt. jp) then
             ubar(j, 0)=-2.0*(s1-s2)/dx
           elseif (j .gt. jp) then
             ubar(j, 0)=2.0*(s1-s2)/dx
           else
             p1=-2.0*(cos(0.5*par)-s2)/dx
             p2=2.0*(s1-cos(0.5*par))/dx
             ubar(j, 0)=p1+p2
          endif

       enddo

 99    do NR=0, 2

       do k=0, NN-1
           k1=k-0.5*(NN-1)
           ss=0.0
           do j=0, NN-1
              s1=cos(k1*x(j))
              s2=-sin(k1*x(j))
              ss=ss+ubar(j,NR)*cmplx(s1,s2)
           enddo
           abar(k)=ss/NN
       enddo

       do k=0, NN-1
           k1=k-0.5*(NN-1)
           if (k1 .eq. 0) then
           si(k)=1.0
           else
           si(k)=sin(0.5*k1*dx)/(0.5*k1*dx)
           endif
           al(k)=abar(k)/si(k)
       enddo

      do j=0, NN-1
          xj=(j+0.5)*dx
          sum=0.0

          do k=1, N
             tau=exp(-alpha*(1.0*k/N)**20)

             ps=k*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=al(k+N)*ss2
             sum=sum+tau*ss

             k1=-k
             ps=k1*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=al(k1+N)*ss2

             sum=sum+tau*ss
          enddo

          uapp1(j)=real(al(N)+sum) 

       enddo

       do j=0, NN-1
          ss1=uapp1(j)
          if (j .eq. 0) then
             ss2=uapp1(NN-1)
             else
             ss2=uapp1(j-1)
          endif
          xL(j, NR)=-0.5*(ss1*ss1-ss2*ss2)/dx

          if (NR .eq. 0) then
             ubar(j,1)=ubar(j,0)+dt*xL(j,0)
          endif

          if (NR .eq. 1) then
             sa=0.75*ubar(j,0)+0.25*ubar(j,1)+0.25*dt*xL(j,1)
             ubar(j,2)=sa
          endif

          if (NR .eq. 2) then
             sa=ubar(j,0)/3.0+ubar(j,2)*2/3.0+dt*xL(j,2)*2/3.0
             ubar(j,3)=sa
          endif

        enddo

       enddo

       ttime=ttime+dt
       print *, ttime, '    time'
       if (ttime .lt. Tmax) then
          do j=0, NN
            ubar(j,0)=ubar(j, 3)
          enddo
          goto 99
       endif

       do k=0, NN-1
           k1=k-0.5*(NN-1)
           ss=0.0
           do j=0, NN-1
              p1=k1*x(j)
              s1=cos(p1)
              s2=-sin(p1)
              ss=ss+ubar(j,NR)*cmplx(s1,s2)
           enddo
           abar(k)=ss/NN
           al(k)=abar(k)/si(k)
       enddo

      do j=0, NN-1
          xj=x(j)
          sum=0.0

          do k=1, N
             tau=exp(-alpha*(1.0*k/N)**4)

             ps=k*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=al(k+N)*ss2
             sum=sum+tau*ss

             k1=-k
             ps=k1*xj
             s1=cos(ps)
             s2=sin(ps)
             ss2=cmplx(s1, s2)
             ss=al(k1+N)*ss2

             sum=sum+tau*ss
          enddo

          uapp1(j)=real(al(N)+sum)

       enddo

       write (17, *) 'x=['
       do j=0, NN-1
          write (17, *) x(j)
       enddo
       write (17, *) '];'

        write (18, *) 'y=['
       do j=0, NN-1
          write (18, *) uapp1(j)
       enddo
       write (18, *) '];'

       print *, A, y, '   A, y'
       
       stop
       end

       parameter (MM=2, NN=4)
       dimension al(0:NN), c(0:MM,0:NN,0:NN), Dm(0:NN,0:NN)

       pi=4.0*atan(1.0)
       do 5 j=0, NN
       al(j)=cos(pi*j/NN)
 5     continue
   
       do 10  j=0, NN
          zeta=al(j)
          c(0,0,0)=1
          c1=1

          do 20 n=1, NN
             c2=1
             do 30 nu=0, n-1
               c3=al(n)-al(nu)
               c2=c2*c3
               do 35 m=0, MM
                 if (m .gt. 0) then
                    ss=m*c(m-1,n-1,nu)
                 else
                    ss=0
                 endif
                 c(m,n,nu)=((al(n)-zeta)*c(m,n-1,nu)-ss)/c3
 35            continue
 30          continue          
             do 40 m=0, MM
                if (m .gt. 0) then
                   ss=m*c(m-1,n-1,n-1)
                else
                   ss=0
                endif
                c(m,n,n)=c1*(ss-(al(n-1)-zeta)*c(m,n-1,n-1))/c2
  40         continue
          c1=c2
  20      continue
       do 50 nu=0, NN
          Dm(j, nu)=c(MM,NN,nu)
  50   continue
  10   continue

       do 60 i=0,NN
        write (11, 99) Dm(i, 0), Dm(i,1), Dm(i,2), Dm(i,3), Dm(i,4)
 60    continue

 99    format (5(1x, f9.4))
       stop
       end

       parameter (N=64, NN=2*N+1)
       implicit real*8(a-h,o-z)
       real x(0:NN), uapp(0:NN), exact(0:NN)
       complex uhat(0:NN)
       complex w, A, y, ss, ss1, ss2, A1

       pi=4.0*atan(1.0)
       w=cmplx(0, 1)
       pa=1.9

       do k=0, NN-1
           k1=k-N
           p1=(k1+0.5)*pa
           p2=(k1-0.5)*pa
           s1=(-cos(p1)/(k1+0.5)+cos(p2)/(k1-0.5))/(2*pi)
           s2=(sin(p1)/(k1+0.5)-sin(p2)/(k1-0.5))/(2*pi)
           uhat(k)=cmplx(s1,s2)
       enddo

       ss=(N-1)*uhat(N+N-1)/(N*uhat(N+N))
       y=-w*log(ss)
       y=real(y)
       err1=abs(real(y)-pa)
       print *, err1, '   error in position'

       ss=w*(N-1)*y
       A=w*(N-1)*uhat(N+N-1)*exp(ss)
       A=real(A)
       err2=abs(-sin(0.95)/pi-real(A))
       print *, err2, '   error in strength'

      do j=0, 2*N
         x(j)=2*pi*j/(2*N+1)
          if (x(j) .le. real(y)) then
             F=-real(A)*x(j)
             exact(j)=sin(0.5*x(j))
          else
             F=real(A)*(2*pi-x(j))
             exact(j)=-sin(0.5*x(j))
          endif
         
          sum=0.0
          do k=1, N
             tau=exp(-15*log(10.0)*(1.0*k/N)**8)
             ss1=-w*k*y
             ss2=w*k*x(j)
             ss=(uhat(k+N)+w*A*exp(ss1)/k)*exp(ss2)
             sum=sum+tau*ss
             k1=-k
             ss1=-w*k1*y
             ss2=w*k1*x(j)
             ss=(uhat(k1+N)+w*A*exp(ss1)/k1)*exp(ss2)
             sum=sum+tau*ss
          enddo

          uapp(j)=real(uhat(N)-A*(pi-y)+sum+F)
c          print *, uapp(j), exact(j), abs(uapp(j)-exact(j))
       enddo

       write (17, *) 'x=['
       do j=0, NN-1
          write (17, *) x(j)
       enddo
       write (17, *) '];'

        write (18, *) 'y=['
       do j=0, NN-1
          write (18, *) real(uapp(j))
       enddo
       write (18, *) '];'

       write (19, *) 'y=['
       do j=0, NN-1
          write (19, *) abs(uapp(j)-exact(j))
       enddo
       write (19, *) '];'

c          write (19, *) abs(uapp(j)-exact(j))

          
       stop
       end
